// TScriptReport VCL component for BCB
// Copyright Michael M. Koltachev, Vladimir A. Samoylov
// IAE SB RAS 1999

#ifndef RwMainHPP
#define RwMainHPP
#include <SysUtils.hpp>
#include <SyncObjs.hpp>
#include <ComCtrls.hpp>
#include <StdCtrls.hpp>
#include <Printers.hpp>
#include <Graphics.hpp>
#include <ExtCtrls.hpp>
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>

namespace Rwmain {

typedef bool __fastcall (__closure *TExtfunction)(System::AnsiString ExtName, 
	System::AnsiString &Data, bool &MoreValues);
enum TReportExecMode { emModal, emAsyncExec, emSyncExec };
enum TPageRangeFilter { prfAll, prfOdd, prfEven };

class TScriptReport;
class PASCALIMPLEMENTATION TScriptReport: public Classes::TComponent {
	typedef Classes::TComponent inherited;
private:
	System::AnsiString FDatabaseName;
	Classes::TStringList* FBody;
	Extctrls::TImage* FImg;
	bool FNewReport;
	TExtfunction FExtFunc;
	TReportExecMode FExecMode;
	Syncobjs::TEvent* FEvent;
	int OriginalImgPixelsPerInch;
	Graphics::TCanvas* _AtCanvas;
	int FNumPages;
	Syncobjs::TEvent* EventModalShown;
	void __fastcall SetBody(Classes::TStringList* NewBody);
	Word __fastcall ShowModalDialogProc(void);
	void __fastcall KillModalDialogOK(void);
	void __fastcall KillModalDialogCancel(Sysutils::Exception* E);
	void __fastcall SetDlgLang(int ALang);
	int __fastcall GetDlgLang(void);
protected:
	System::AnsiString __fastcall Test(void);
	virtual void __fastcall Exec(Graphics::TCanvas* AtCanvas);
	virtual void __fastcall ExecInThread(void);
public:
	int ExecTimeout;
	__property int NumPages = {read=FNumPages, write=FNumPages, nodefault};
	__fastcall virtual TScriptReport(Classes::TComponent* AOwner);
	__fastcall virtual ~TScriptReport(void);
	virtual void __fastcall Show(int PageNum);
	virtual void __fastcall ShowUsingScale(int PageNum, int Scale);
	virtual void __fastcall PrintAll(void);
	virtual void __fastcall Print(System::AnsiString Range, TPageRangeFilter Filter);
	virtual bool __fastcall ExtFunction(System::AnsiString ExtName, System::AnsiString &Data, bool &More
		);
	void __fastcall Check(Graphics::TCanvas* ACanvas, Comctrls::TTreeView* TV, Stdctrls::TListBox* LB);
		
	__property bool NewReport = {read=FNewReport, write=FNewReport, nodefault};
	__property int DialogLanguage = {read=GetDlgLang, write=SetDlgLang, nodefault};
	__property Syncobjs::TEvent* Event = {read=FEvent};
__published:
	__property System::AnsiString DatabaseName = {read=FDatabaseName, write=FDatabaseName};
	__property Classes::TStringList* Src = {read=FBody, write=SetBody};
	__property Extctrls::TImage* Img = {read=FImg, write=FImg};
	__property TReportExecMode ExecMode = {read=FExecMode, write=FExecMode, nodefault};
	__property TExtfunction ExtFunc = {read=FExtFunc, write=FExtFunc};
};

extern PACKAGE void __fastcall Register(void);

}	/* namespace Rwmain */

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Rwmain;
#endif
#endif	// RwMain
