unit RwModal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TFormRWDialog = class(TForm)
    LabelMsg: TLabel;
    LabelWait: TLabel;
    BtnStop: TButton;
    BtnMinimize: TButton;
    procedure BtnStopClick(Sender: TObject);
    procedure BtnMinimizeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  protected
    procedure WndProc(var Message: TMessage);  override;
  public
    procedure ExitModalOk;
    procedure ExitModalCancel;
  end;

const
  WM_EXITMODAL = WM_USER + $F001;

var
  FormRWDialog: TFormRWDialog;

implementation
{$R *.DFM}
uses RwScan;

procedure TFormRWDialog.BtnStopClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TFormRWDialog.BtnMinimizeClick(Sender: TObject);
begin
  Application.Minimize;
end;

procedure TFormRWDialog.ExitModalOk;
begin
  PostMessage(Handle, WM_EXITMODAL, mrOk, 0);
end;

procedure TFormRWDialog.ExitModalCancel;
begin
  PostMessage(Handle, WM_EXITMODAL, mrCancel, 0);
end;

procedure TFormRWDialog.WndProc(var Message: TMessage);
begin
  with Message do
    if (Msg = WM_EXITMODAL) then
      ModalResult := WParam;
  inherited WndProc(Message);
end;

procedure TFormRWDialog.FormCreate(Sender: TObject);
begin
  case DlgLang of
    dlRus: begin
        Caption := '!';
        LabelMsg.Caption  := '  ';
        LabelWait.Caption := ' ...';
        BtnStop.Caption   := '';
      end;
  end;
end;

end.

